[LeetCode]75.Sort Colors

【题目连接】

75.Sort Colors

【题目】

Given an array with n objects colored red, white or blue, sort them so that objects of the same color are adjacent, with the colors in the order red, white and blue.

Here, we will use the integers 0, 1, and 2 to represent the color red, white, and blue respectively.

Note:
You are not suppose to use the library's sort function for this problem.

click to show follow up.

Follow up:
A rather straight forward solution is a two-pass algorithm using counting sort.
First, iterate the array counting number of 0's, 1's, and 2's, then overwrite array with total number of 0's, then 1's and followed by 2's.

Could you come up with an one-pass algorithm using only constant space?

【分析】

A rather straight forward solution is a two-pass algorithm using counting sort.
First, iterate the array counting number of 0's, 1's, and 2's, then overwrite array with total number of 0's, then 1's and followed
by 2's.

这是我们首先会想到的。可是题目要求我们不能这样。

【代码】

    /**------------------------------------
    *   日期:2015-02-02
    *   作者:SJF0115
    *   题目: 75.Sort Colors
    *   网址:https://oj.leetcode.com/problems/sort-colors/
    *   结果:AC
    *   来源:LeetCode
    *   博客:
    ---------------------------------------**/
    #include <iostream>
    #include <vector>
    #include <algorithm>
    using namespace std;

    class Solution {
    public:
        void sortColors(int A[], int n) {
            if(n <= 1){
                return;
            }//if
            // 统计个数
            int red = 0,white = 0,blue = 0;
            for(int i = 0;i < n;++i){
                if(A[i] == 0){
                    ++red;
                }//if
                else if(A[i] == 1){
                    ++white;
                }//else
                else{
                    ++blue;
                }//else
            }//for
            // 重新布局
            for(int i = 0;i < n;++i){
                if(red > 0){
                    A[i] = 0;
                    --red;
                }//if
                else if(white > 0){
                    A[i] = 1;
                    --white;
                }//else
                else{
                    A[i] = 2;
                }
            }//for
        }
    };

    int main(){
        Solution s;
        int A[] = {0,0,1,0,2,0,1,2};
        s.sortColors(A,8);
        for(int i = 0;i < 8;++i){
            cout<<A[i]<<endl;
        }//for
        // 输出
        return 0;
    }

【思路二】

用三个变量记录red,white,blue的下标位置。起始下标都为-1

如果A[i] == 0 ,插入red对white blue有影响,blue先整体向后移动一位,white再整体向后移动一位,如果不移动,前面插入的数据就会覆盖已有的。

如果A[i] == 1,插入white对blue有影响,blue整体向后移动一位。

A[i] == 2,直接插入blue

【代码二】

    /**------------------------------------
    *   日期:2015-02-03
    *   作者:SJF0115
    *   题目: 75.Sort Colors
    *   网址:https://oj.leetcode.com/problems/sort-colors/
    *   结果:AC
    *   来源:LeetCode
    *   博客:
    ---------------------------------------**/
    #include <iostream>
    #include <vector>
    #include <algorithm>
    using namespace std;

    class Solution {
    public:
        void sortColors(int A[], int n) {
            if(n <= 1){
                return;
            }//if
            int red = -1,white = -1,blue = -1;
            for(int i = 0;i < n;++i){
                // 插入red对white blue有影响
                if(A[i] == 0){
                    // blue整体向后移动一位
                    A[++blue] = 2;
                    // white整体向后移动一位
                    A[++white] = 1;
                    // 插入red
                    A[++red] = 0;
                }//if
                // 插入white blue受到影响
                else if(A[i] == 1){
                    // blue整体向后移动一位
                    A[++blue] = 2;
                    // 插入white
                    A[++white] = 1;
                }//else
                // 插入blue对其他没有影响
                else{
                    // 插入blue
                    A[++blue] = 2;
                }//else
            }//for
        }
    };

    int main(){
        Solution s;
        int A[] = {0,0,1,0,2,0,1,2};
        s.sortColors(A,8);
        for(int i = 0;i < 8;++i){
            cout<<A[i]<<endl;
        }//for
        // 输出
        return 0;
    }


【思路三】

冒泡排序

class Solution {
public:
    void sortColors(int A[], int n) {
        for(int i=0;i<n;i++){
            for(int j=0;j<n-i-1;j++){
                if(A[j]>A[j+1]){
                    int tmp=A[j];
                    A[j]=A[j+1];
                    A[j+1]=tmp;
                }
            }
        }
    }
};

【思路四】

我们可以把数组分成三部分,前部(全部是0),中部(全部是1)和后部(全部是2)三个部分,每一个元素(红白蓝分别对应0、1、2)必属于其中之一。

将前部和后部各排在数组的前边和后边,中部自然就排好了。

设置两个指针begin指向前部的末尾的下一个元素(刚开始默认前部无0,所以指向第一个位置),end指向后部开头的前一个位置(刚开始默认后部无2,所以指向最后一个位置),然后设置一个遍历指针current,从头开始进行遍历。

(1)若遍历到的位置为1,则说明它一定属于中部,根据总思路,中部的我们都不动,然后current向前移动一个位置。

(2)若遍历到的位置为0,则说明它一定属于前部,于是就和begin位置进行交换,然后current向前移动一个位置,begin也向前移动一个位置(表示前边的已经都排好了)。

(3)若遍历到的位置为2,则说明它一定属于后部,于是就和end位置进行交换,由于交换完毕后current指向的可能是属于前部的,若此时current前进则会导致该位置不能被交换到前部,所以此时current不前进。而同1),end向前移动一个位置。

【代码四】

    /**------------------------------------
    *   日期:2015-02-04
    *   作者:SJF0115
    *   题目: 75.Sort Colors
    *   网址:https://oj.leetcode.com/problems/sort-colors/
    *   结果:AC
    *   来源:LeetCode
    *   博客:
    ---------------------------------------**/
   class Solution {
    public:
        void sortColors(int A[], int n) {
            int begin = 0,end = n-1,cur = 0;
            while(cur <= end){
                if(A[cur] == 0){
                    swap(A[begin],A[cur]);
                    // 指向排序0末尾的下一个位置
                    ++begin;
                    // 向前遍历
                    ++cur;
                }//if
                else if(A[cur] == 1){
                    ++cur;
                }//else
                else{
                    swap(A[end],A[cur]);
                    // 指向排序2开头的前一个位置
                    --end;
                }//else
            }//for
        }
    };

详细参考:[算法系列之十一]荷兰国旗问题

时间: 2024-08-31 18:00:41

[LeetCode]75.Sort Colors的相关文章

[LeetCode]148.Sort List

[题目] Sort a linked list in O(n log n) time using constant space complexity. [分析] 单链表适合用归并排序,双向链表适合用快速排序.本题可以复用Merge Two Sorted Lists方法 [代码] /********************************* * 日期:2015-01-12 * 作者:SJF0115 * 题目: 148.Sort List * 来源:https://oj.leetcode.c

Sort Colors

Given an array with n objects colored red, white or blue, sort them so that objects of the same color are adjacent, with the colors in the order red, white and blue. Here, we will use the integers 0, 1, and 2 to represent the color red, white, and bl

leetcode难度及面试频率

转载自:LeetCode Question Difficulty Distribution               1 Two Sum 2 5 array sort         set Two Pointers 2 Add Two Numbers 3 4 linked list Two Pointers           Math 3 Longest Substring Without Repeating Characters 3 2 string Two Pointers      

LeetCode All in One 题目讲解汇总(持续更新中...)

终于将LeetCode的免费题刷完了,真是漫长的第一遍啊,估计很多题都忘的差不多了,这次开个题目汇总贴,并附上每道题目的解题连接,方便之后查阅吧~ 如果各位看官们,大神们发现了任何错误,或是代码无法通过OJ,或是有更好的解法,或是有任何疑问,意见和建议的话,请一定要在对应的帖子下面评论区留言告知博主啊,多谢多谢,祝大家刷得愉快,刷得精彩,刷出美好未来- 博主制作了一款iOS的应用"Leetcode Meet Me",里面有Leetcode上所有的题目,并且贴上了博主的解法,随时随地都能

[算法系列之十一]荷兰国旗问题

[问题] 现有红白蓝三个不同颜色的小球,乱序排列在一起,请重新排列这些小球,使得红白蓝三色的同颜色的球在一起.这个问题之所以叫荷兰国旗问题,是因为我们可以将红白蓝三色小球想象成条状物,有序排列后正好组成荷兰国旗. [分析] 这个问题我们可以将这个问题视为一个数组排序问题.红白蓝分别对应数字0.1.2.红.白.蓝三色小球数量并不一定相同. [思路一] First, iterate the array counting number of 0's, 1's, and 2's, then overwr

LeetCode总结【转】

转自:http://blog.csdn.net/lanxu_yy/article/details/17848219 版权声明:本文为博主原创文章,未经博主允许不得转载. 最近完成了www.leetcode.com的online judge中151道算法题目.除各个题目有特殊巧妙的解法以外,大部分题目都是经典的算法或者数据结构,因此做了如下小结,具体的解题思路可以搜索我的博客:LeetCode题解 题目 算法 数据结构 注意事项 Clone Graph BFS 哈希表 Word Ladder II

求EXT2.0 画图解放方案

问题描述 求EXT2.0 图画解放方案就是像柱状,饼状,线等等的EXT2.0的,能用的,谢谢了 解决方案 //pieChart.jsExt.ns('Ext.ux');Ext.ux.pieChart = Ext.extend(Ext.BoxComponent, {circleX : 0,circleY : 0,data : undefined,labels : [],labelX : 0,labelY : 0,radius : 100,onRender : function(ct, positio

产生渐变色的view

产生渐变色的view   效果   源码 https://github.com/YouXianMing/UI-Component-Collection // // GradientColorView.h // GradientColorView // // Created by YouXianMing on 15/12/15. // Copyright 2015年 YouXianMing. All rights reserved. // #import <UIKit/UIKit.h> @int

百度:求绝对值最小的数

我只是从网上搜集的,下面的代码或许有错误. 看了会Hadoop,和传华聊了会,他说,他们那三等奖8000,:打算要回宿舍了,不经意间看到了这个题,貌似简单,其实还是比较有难度的. 一段时间只能干一件事就行了. 有一个已经排序的数组(升序),数组中可能有正数.负数或0,求数组中元素的绝对值最小的数,要求,不能用顺序比较的方法(复杂度需要小于O(n)),可以使用任何语言实现,例如,数组{-20,-13,-4, 6, 77,200} ,绝对值最小的是-4.  算法实现的基本思路:找到负数和正数的分界点